<?php
class DediManiaRecords extends Plugin {

  private $openwindows;
  private $records_to_show = 30;

function displayDedirecs($command) {
    // create a window if there's not an open one already ...
    if ($this->existsPlayerData($command['author'], 'window')) {
      $window = $this->getPlayerData($command['author'], 'window');
      $window->maximize();
    } else {
      $window = $this->createWindowToPlayerFramework('Top '. $this->records_to_show .' DediRecords on '.cutString(stripFormatting($this->Aseco->server->challenge->name), 23, stripFormatting($this->Aseco->server->challenge->name)), 1.0, 0.58, $command['author']);
      $window->addCallback('close', 'closeDediRecords'); // add close callback
      $this->storePlayerData($command['author'], 'window', $window);
    }

    // build the message string ...
    $message = '';
    $header = '<line><cell bgcolor="cccf" width="0.25"><text halign="center">$000Position</text></cell><cell bgcolor="cccf" width="0.50"><text halign="center">$000Player</text></cell><cell bgcolor="cccf" width="0.25"><text halign="center">$000';
    if ( $this->Aseco->server->gameinfo->getMode() == 'Stunts' ) {
      $header .= 'Score';
    } else {
      $header .= 'Time';
    }
    $header .= '</text></cell></line>';
	
    $dedi_records = $this->Aseco->getPlugin("DediMania")->dedi_db['Challenge']['Records'];
	if (!$dedi_records) { 
	$message .= '<line>';
        $message .= '<cell><text>Currently there are no records driven ...</text></cell>';
        $message .= '</line>';
    	} else {
    
      	if ($total = count($dedi_records)) {
				for ($i = 0; $i < $total; $i++) {
        	$dedi_record = $dedi_records[$i];
        $message .= '<line>';
        $message .= '<cell width="0.20"><text halign="center">$f00$o'.($i + 1).'</text></cell>';
        $message .= '<cell width="0.60"><text halign="center">' . htmlspecialchars($dedi_record['NickName']) . '</text></cell>';
	if ( $this->Aseco->server->gameinfo->getMode() == 'Stunts' )
        {
		$s = $dedi_record['Best'];
        }
        else
        {
		$s = formatTime($dedi_record['Best']);
				}
        $message .= '<cell width="0.20"><text halign="center">'. $s .'</text></cell>';
        $message .= '</line>';
	$footer = '<line height="0.04"><cell width="1.0"></cell></line><line height="0.05"><cell bgcolor="cccf" width="1.0"><text halign="center">$L[http://www.dedimania.com]$f00Powered by DediMania$L</text></cell></line>';
        if (($i + 1) % 10 == 0) {
          $messages[] = $header . $message . $footer;
          $message = '';
         }
      }
   }
}
      
    	if ($message != '') {
   	$messages[] = $header . $message . $footer;
	}
    	// set the window's content ...
    	$window->setContent($messages);
    	$window->show();
  	}
    

  	function closeDediRecords($param, $window, $player) {
   	 $this->removePlayerData($player, 'window');
 	}

	function showdediRecordsToPlayer($player) {
    	$this->displayDedirecs(array('author' => $player));
  	}
	function init() {
    	$statusbar = $this->Aseco->getPlugin('Statusbar');
    	if ($statusbar) {
      	$statusbar->addButton('DediRecs', $this, 'showdediRecordsToPlayer', 0.11);
    	}
  }

  	function setRecordsToShow($in_recs_to_show) {
    	$this->records_to_show = $in_recs_to_show;
  	}
}

$_PLUGIN = new DediManiaRecords();
$_PLUGIN->setAuthor('CavalierDeVache');
$_PLUGIN->setVersion(0.6);
$_PLUGIN->addDependence('DediMania', 0.5, null);
$_PLUGIN->setDescription('Displays the top 30 DediMania World records on the current track.');
$_PLUGIN->addChatCommand('dedirecs', 'displayDedirecs', 'shows records of the current map.');
$_PLUGIN->addEvent('onSync', 'init');
$_PLUGIN->setWebsite('http://www.tm-slowpokes.com');
?>
